import astropy,os,scipy
#from pyfits import getdata
#from pyfits import getheader
#from pyfits import getval
import numpy as np
from astropy.io import fits
from scipy.ndimage import gaussian_filter1d

line_a=fits.open('../linear_a.fits')
line_b=fits.open('../linear_b.fits')
name_filter=['g','bokr','r','z','u']

def func(x,b):
    return np.exp(b/x)

os.system('ls e*.fits > fits.lst')

filename=open('fits.lst','r')
date=next(filename)[1:5]
filename.close()

x=np.linspace(0,2047,2048)
y=np.linspace(0,0,2048)

for line in open("fits.lst"):
    line=line.strip("\n")
    
    objectname=fits.getval(line,'IMAGETYP',0)
    if (objectname != 'zero') and (objectname != 'flat'):

        filter=fits.getval(line,'FILTER',0)
        print(line,objectname,filter)
        for i in range(5):
            if (filter == name_filter[i]):
                flat_name='flat_'+date+'_'+name_filter[i]+'.fits'
                flat_sky_name='flat_'+date+'_'+name_filter[i]+'_sky.fits'
                flat_sky=fits.open(flat_sky_name)
                flat=fits.open(flat_name)

        object=fits.open(line)

        for k in range(16):    
            if (k == 8) or (k ==9) or (k == 10) or (k == 11):
                xdata=object[k+1].data[:,:2016]
                xdata[xdata < 1.0] = 1.0
#                np.place(object[k+1].data[:,:2016],object[k+1].data[:,:2016] < 1,1)
                para_a=line_a[k+1].data[:,:2016]
                para_b=line_b[k+1].data[:,:2016]

#                print xdata[100,100],para_a[100,100],para_b[100,100]
                object[k+1].data[:,:2016]/=func(xdata,para_b)
#                print object[k+1].data[100,100]

            object[k+1].data[:,:2016]/=flat_sky[k+1].data[:,:2016]

        line1=line.replace('e','p')
        object.writeto(line1[:15],clobber='Ture')
        object.close()

flat.close()
flat_sky.close()
